opencv: CvANN_MLP Class Reference

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes

# CvANN_MLP Class Reference

`#include <ml.hpp>`

Inheritance diagram for CvANN_MLP:

List of all members.

## Public Types
enum | { IDENTITY = 0, SIGMOID_SYM = 1, GAUSSIAN = 2 }
enum | { UPDATE_WEIGHTS = 1, NO_INPUT_SCALE = 2, NO_OUTPUT_SCALE = 4 }
## Public Member Functions
virtual CV_WRAP void | clear ()
virtual void | create (const CvMat *layerSizes, int activateFunc=CvANN_MLP::SIGMOID_SYM, double fparam1=0, double fparam2=0)
virtual CV_WRAP void | create (const cv::Mat &layerSizes, int activateFunc=CvANN_MLP::SIGMOID_SYM, double fparam1=0, double fparam2=0)
CV_WRAP | CvANN_MLP ()
| CvANN_MLP (const CvMat *layerSizes, int activateFunc=CvANN_MLP::SIGMOID_SYM, double fparam1=0, double fparam2=0)
CV_WRAP | CvANN_MLP (const cv::Mat &layerSizes, int activateFunc=CvANN_MLP::SIGMOID_SYM, double fparam1=0, double fparam2=0)
int | get_layer_count ()
const CvMat * | get_layer_sizes ()
double * | get_weights (int layer)
virtual float | predict (const CvMat *inputs, CV_OUT CvMat *outputs) const
virtual CV_WRAP float | predict (const cv::Mat &inputs, cv::Mat &outputs) const
virtual void | read (CvFileStorage *fs, CvFileNode *node)
virtual int | train (const CvMat *inputs, const CvMat *outputs, const CvMat *sampleWeights, const CvMat *sampleIdx=0, CvANN_MLP_TrainParams params=CvANN_MLP_TrainParams(), int flags=0)
virtual CV_WRAP int | train (const cv::Mat &inputs, const cv::Mat &outputs, const cv::Mat &sampleWeights, const cv::Mat &sampleIdx=cv::Mat(), CvANN_MLP_TrainParams params=CvANN_MLP_TrainParams(), int flags=0)
virtual void | write (CvFileStorage *storage, const char *name) const
virtual | ~CvANN_MLP ()
## Protected Member Functions
virtual void | calc_activ_func (CvMat *xf, const double *bias) const
virtual void | calc_activ_func_deriv (CvMat *xf, CvMat *deriv, const double *bias) const
virtual void | calc_input_scale (const CvVectors *vecs, int flags)
virtual void | calc_output_scale (const CvVectors *vecs, int flags)
virtual void | init_weights ()
virtual bool | prepare_to_train (const CvMat *_inputs, const CvMat *_outputs, const CvMat *_sample_weights, const CvMat *sampleIdx, CvVectors *_ivecs, CvVectors *_ovecs, double **_sw, int _flags)
virtual void | read_params (CvFileStorage *fs, CvFileNode *node)
virtual void | scale_input (const CvMat *_src, CvMat *_dst) const
virtual void | scale_output (const CvMat *_src, CvMat *_dst) const
virtual void | set_activ_func (int _activ_func=SIGMOID_SYM, double _f_param1=0, double _f_param2=0)
virtual int | train_backprop (CvVectors _ivecs, CvVectors _ovecs, const double *_sw)
virtual int | train_rprop (CvVectors _ivecs, CvVectors _ovecs, const double *_sw)
virtual void | write_params (CvFileStorage *fs) const
## Protected Attributes
int | activ_func
double | f_param1
double | f_param2
CvMat * | layer_sizes
int | max_buf_sz
int | max_count
double | max_val
double | max_val1
double | min_val
double | min_val1
CvANN_MLP_TrainParams | params
cv::RNG * | rng
CvMat * | sample_weights
CvMat * | wbuf
double ** | weights

## Member Enumeration Documentation

anonymous enum

Enumerator:

  IDENTITY |
  SIGMOID_SYM |
  GAUSSIAN |

anonymous enum

Enumerator:

  UPDATE_WEIGHTS |
  NO_INPUT_SCALE |
  NO_OUTPUT_SCALE |

## Constructor & Destructor Documentation

CV_WRAP CvANN_MLP::CvANN_MLP | ( | ) |

CvANN_MLP::CvANN_MLP | ( | const CvMat * | layerSizes,
|  | int | activateFunc = `CvANN_MLP::SIGMOID_SYM`,
|  | double | fparam1 = `0`,
|  | double | fparam2 = `0`
| ) |  |

virtual CvANN_MLP::~CvANN_MLP | ( | ) | `[virtual]`

CV_WRAP CvANN_MLP::CvANN_MLP | ( | const cv::Mat & | layerSizes,
|  | int | activateFunc = `CvANN_MLP::SIGMOID_SYM`,
|  | double | fparam1 = `0`,
|  | double | fparam2 = `0`
| ) |  |

## Member Function Documentation

virtual void CvANN_MLP::calc_activ_func | ( | CvMat * | xf,
|  | const double * | bias
| ) |  | const`[protected, virtual]`

virtual void CvANN_MLP::calc_activ_func_deriv | ( | CvMat * | xf,
|  | CvMat * | deriv,
|  | const double * | bias
| ) |  | const`[protected, virtual]`

virtual void CvANN_MLP::calc_input_scale | ( | const CvVectors * | vecs,
|  | int | flags
| ) |  | `[protected, virtual]`

virtual void CvANN_MLP::calc_output_scale | ( | const CvVectors * | vecs,
|  | int | flags
| ) |  | `[protected, virtual]`

virtual CV_WRAP void CvANN_MLP::clear | ( | ) | `[virtual]`

Reimplemented from CvStatModel.

virtual CV_WRAP void CvANN_MLP::create | ( | const cv::Mat & | layerSizes,
|  | int | activateFunc = `CvANN_MLP::SIGMOID_SYM`,
|  | double | fparam1 = `0`,
|  | double | fparam2 = `0`
| ) |  | `[virtual]`

virtual void CvANN_MLP::create | ( | const CvMat * | layerSizes,
|  | int | activateFunc = `CvANN_MLP::SIGMOID_SYM`,
|  | double | fparam1 = `0`,
|  | double | fparam2 = `0`
| ) |  | `[virtual]`

int CvANN_MLP::get_layer_count | ( | ) | `[inline]`

const CvMat* CvANN_MLP::get_layer_sizes | ( | ) | `[inline]`

double* CvANN_MLP::get_weights | ( | int | layer ) | `[inline]`

virtual void CvANN_MLP::init_weights | ( | ) | `[protected, virtual]`

virtual CV_WRAP float CvANN_MLP::predict | ( | const cv::Mat & | inputs,
|  | cv::Mat & | outputs
| ) |  | const`[virtual]`

virtual float CvANN_MLP::predict | ( | const CvMat * | inputs,
|  | CV_OUT CvMat * | outputs
| ) |  | const`[virtual]`

virtual bool CvANN_MLP::prepare_to_train | ( | const CvMat * | _inputs,
|  | const CvMat * | _outputs,
|  | const CvMat * | _sample_weights,
|  | const CvMat * | sampleIdx,
|  | CvVectors * | _ivecs,
|  | CvVectors * | _ovecs,
|  | double ** | _sw,
|  | int | _flags
| ) |  | `[protected, virtual]`

virtual void CvANN_MLP::read | ( | CvFileStorage * | fs,
|  | CvFileNode * | node
| ) |  | `[virtual]`

Reimplemented from CvStatModel.

virtual void CvANN_MLP::read_params | ( | CvFileStorage * | fs,
|  | CvFileNode * | node
| ) |  | `[protected, virtual]`

virtual void CvANN_MLP::scale_input | ( | const CvMat * | _src,
|  | CvMat * | _dst
| ) |  | const`[protected, virtual]`

virtual void CvANN_MLP::scale_output | ( | const CvMat * | _src,
|  | CvMat * | _dst
| ) |  | const`[protected, virtual]`

virtual void CvANN_MLP::set_activ_func | ( | int | _activ_func = `SIGMOID_SYM`,
|  | double | _f_param1 = `0`,
|  | double | _f_param2 = `0`
| ) |  | `[protected, virtual]`

virtual int CvANN_MLP::train | ( | const CvMat * | inputs,
|  | const CvMat * | outputs,
|  | const CvMat * | sampleWeights,
|  | const CvMat * | sampleIdx = `0`,
|  | CvANN_MLP_TrainParams | params = `CvANN_MLP_TrainParams()`,
|  | int | flags = `0`
| ) |  | `[virtual]`

virtual CV_WRAP int CvANN_MLP::train | ( | const cv::Mat & | inputs,
|  | const cv::Mat & | outputs,
|  | const cv::Mat & | sampleWeights,
|  | const cv::Mat & | sampleIdx = `cv::Mat()`,
|  | CvANN_MLP_TrainParams | params = `CvANN_MLP_TrainParams()`,
|  | int | flags = `0`
| ) |  | `[virtual]`

virtual int CvANN_MLP::train_backprop | ( | CvVectors | _ivecs,
|  | CvVectors | _ovecs,
|  | const double * | _sw
| ) |  | `[protected, virtual]`

virtual int CvANN_MLP::train_rprop | ( | CvVectors | _ivecs,
|  | CvVectors | _ovecs,
|  | const double * | _sw
| ) |  | `[protected, virtual]`

virtual void CvANN_MLP::write | ( | CvFileStorage * | storage,
|  | const char * | name
| ) |  | const`[virtual]`

Reimplemented from CvStatModel.

virtual void CvANN_MLP::write_params | ( | CvFileStorage * | fs ) | const`[protected, virtual]`

## Member Data Documentation

int CvANN_MLP::activ_func`[protected]`

double CvANN_MLP::f_param1`[protected]`

double CvANN_MLP::f_param2`[protected]`

CvMat* CvANN_MLP::layer_sizes`[protected]`

int CvANN_MLP::max_buf_sz`[protected]`

int CvANN_MLP::max_count`[protected]`

double CvANN_MLP::max_val`[protected]`

double CvANN_MLP::max_val1`[protected]`

double CvANN_MLP::min_val`[protected]`

double CvANN_MLP::min_val1`[protected]`

CvANN_MLP_TrainParams CvANN_MLP::params`[protected]`

cv::RNG* CvANN_MLP::rng`[protected]`

CvMat* CvANN_MLP::sample_weights`[protected]`

CvMat* CvANN_MLP::wbuf`[protected]`

double** CvANN_MLP::weights`[protected]`

The documentation for this class was generated from the following file:

- /usr/ports/pobj/OpenCV-2.2.0/OpenCV-2.2.0/modules/ml/include/opencv2/ml/ml.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines